<?
/**
  * This plugin can be used to display the last few comments.

    Updates and documentation can be found here on the Nucleus Wiky:
    http://www.xiffy.nl/wakka/LatestComments



    History:
      v0.91 - Fixed XHTML warning
      v1.0  - Performance enhancement
      v1.1  - option to add extra <br /> between comment
            - change LatestComments(#,0) to LatestComments(#,actual) to
              display comment to actual/current blog.... the old code didn't
              work for some reason
            - added anchor to comment
      v1.2  - e-Musty (krank@krank.hu), 17/07/2004
              supportsFeature function was missing, however the code itself has 
              been already based on its support. This function has been added.
              Now compatible with Nucleus 3.

      admun TODO:
        - use this for count by word...
          $ctext = substr($text, 0, $numberOfCharacters);
          $lastspacepos = strrpos($ctext, ' ');
          $ctext = substr($text, 0, $lastspacepos);
        - <li> see http://forum.nucleuscms.org/viewtopic.php?p=11170#11170
	- merge in Bcms new changes
  */

class NP_LatestComments extends NucleusPlugin {



   function getEventList() { return array(); }
   function getName() { return 'Latest Comments'; }
   function getAuthor()  { return 'anand | moraes | admun | e-Musty'; }
   function getURL()  { return 'http://www.itismylife.com/'; }
   function getVersion() { return '1.2'; }
   function getDescription() {
      return 'This plugin can be used to display the last few comments.';
   }



   function install() {
    $this->createOption('option1','Show short member names instead of real member names?','yesno','yes');
    $this->createOption('option2','Max number of characters in each comment:','text','85');
    $this->createOption('option3','Break comments by words instead of by characters?','yesno','yes');
    $this->createOption('option4','Put extra <br /> between comments?','yesno','yes');
   }



    // Make it compatible w/ Nucleus 3
    function supportsFeature($feature) {
        switch($feature) {
            case 'SqlTablePrefix':
                return 1;
            default:
                return 0;
        }
    }



   // skinvar plugin can have a blogname as second parameter
   function doSkinVar($skinType) {
        global $manager, $blog, $CONF;
        $params = func_get_args();
        $option1 = $this->getOption('option1');
        $option2 = $this->getOption('option2');
        $option3 = $this->getOption('option3');
        $option4 = $this->getOption('option4');



        $numberOfComments   = 5; // default number of comments



        if ($option2) { $numberOfCharacters = $option2; }
            else { $numberOfCharacters = 85; }
        // how many comments will be shown?
        if ($params[1])
            { $numberOfComments = $params[1]; }
        // show comments from all blogs
        if (!$params[2])
            { $blogid = "";}
        // show comments from the actual blog
        else if ($params[2] == "actual")
            { $blogid = " WHERE cblog=".$blog->getID(); }
        // show comments from the default blog
        else if ($params[2] == "default")
            { $blogid = " WHERE cblog=".$CONF['DefaultBlog'];  }
        // show comments from the selected blog id
        else
            { $blogid = " WHERE cblog=".($params[2]); }



        $query = "SELECT cuser, cbody, citem, cmember, cnumber FROM ".sql_table('comment')." ".$blogid." ORDER by ctime DESC LIMIT 0,".$numberOfComments;



        $comments = mysql_query($query);
        while($row = mysql_fetch_object($comments)) {
             $text  = $row->cbody;
             $text  = strip_tags($text);



             // break comments by words
             if ($option3 == "yes") {
                  //only process this loop, if the sting is longer
                  //than $numberOfCharacters
                  if ( strlen($text) > $numberOfCharacters ) {
                       //first cut off the characters
                       //behind $numberOfCharacters
                       $ctext = substr($text,0,$numberOfCharacters);



                       //now find the last " " within the string and
                       //extract the part before that " "
                       $ctext = substr($ctext,0,strrpos($ctext," "));
                  }
                  // else use the string as it is
                  else
                       $ctext = $text;
             }
             // break comments by characters
             else
                { $ctext = substr($text, 0, $numberOfCharacters); }



             if (!$row->cmember) $myname = $row->cuser;
             else {
                    $mem = new MEMBER;
                    $mem->readFromID(intval($row->cmember));
             // show short member names
             if ($option1 == "yes")
                { $myname = $mem->getDisplayName(); }
             // show real member names
             else
                { $myname = $mem->getRealName(); }



             }
             $itemlink = createItemLink($row->citem, '');
             echo "<a href=\"".$IndexURL.$itemlink."#".$row->cnumber."\">".$myname."</a>";
             echo " says ";
             echo $ctext;
             echo "...<br />";
             if ($option4 == 'yes')
                  echo "<br />";



         }


       }
}
?>
